// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_cam_ts_msgs:msg/DeltaTimeTenSeconds.idl
// generated code does not contain a copyright notice

#include "etsi_its_cam_ts_msgs/msg/detail/delta_time_ten_seconds__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
const rosidl_type_hash_t *
etsi_its_cam_ts_msgs__msg__DeltaTimeTenSeconds__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x04, 0xec, 0x91, 0x77, 0x72, 0x0c, 0xae, 0x01,
      0x3c, 0xa7, 0x4b, 0xb3, 0x66, 0x07, 0xf3, 0x40,
      0x45, 0x9d, 0xb9, 0x08, 0x0a, 0x04, 0x14, 0xaf,
      0x9f, 0x64, 0xf2, 0xd1, 0xa4, 0x5a, 0xb5, 0xe2,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_cam_ts_msgs__msg__DeltaTimeTenSeconds__TYPE_NAME[] = "etsi_its_cam_ts_msgs/msg/DeltaTimeTenSeconds";

// Define type names, field names, and default values
static char etsi_its_cam_ts_msgs__msg__DeltaTimeTenSeconds__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_cam_ts_msgs__msg__DeltaTimeTenSeconds__FIELDS[] = {
  {
    {etsi_its_cam_ts_msgs__msg__DeltaTimeTenSeconds__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_cam_ts_msgs__msg__DeltaTimeTenSeconds__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_cam_ts_msgs__msg__DeltaTimeTenSeconds__TYPE_NAME, 44, 44},
      {etsi_its_cam_ts_msgs__msg__DeltaTimeTenSeconds__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# DeltaTimeTenSeconds ::= INTEGER  (0..127)  \n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE represents a difference in time with respect to a reference time.\n"
  "# *\n"
  "# * The value shall be set to:\n"
  "# * - `-0` for a difference in time of 0 seconds. \n"
  "# * - `n` (`n > 0` and `n < 128`) to indicate a time value equal to or less than n x 10 s, and greater than (n-1) x 10 s,\n"
  "# *\n"
  "# * @unit: 10 s\n"
  "# * @category: Basic information\n"
  "# * @revision: Created in V2.2.1\n"
  "#\n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 127\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_cam_ts_msgs__msg__DeltaTimeTenSeconds__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_cam_ts_msgs__msg__DeltaTimeTenSeconds__TYPE_NAME, 44, 44},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2116, 2116},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_cam_ts_msgs__msg__DeltaTimeTenSeconds__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_cam_ts_msgs__msg__DeltaTimeTenSeconds__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
