// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_cam_ts_msgs:msg/SensorTypes.idl
// generated code does not contain a copyright notice

#include "etsi_its_cam_ts_msgs/msg/detail/sensor_types__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
const rosidl_type_hash_t *
etsi_its_cam_ts_msgs__msg__SensorTypes__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xc1, 0x99, 0x44, 0x11, 0xd2, 0x85, 0x26, 0xe3,
      0x07, 0x62, 0x0b, 0x93, 0x40, 0xda, 0x88, 0xf2,
      0xf9, 0xb4, 0xf3, 0xaa, 0xd2, 0xe5, 0xa2, 0x38,
      0x76, 0x6f, 0xba, 0xfb, 0x16, 0x3e, 0x76, 0xfc,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_cam_ts_msgs__msg__SensorTypes__TYPE_NAME[] = "etsi_its_cam_ts_msgs/msg/SensorTypes";

// Define type names, field names, and default values
static char etsi_its_cam_ts_msgs__msg__SensorTypes__FIELD_NAME__value[] = "value";
static char etsi_its_cam_ts_msgs__msg__SensorTypes__FIELD_NAME__bits_unused[] = "bits_unused";

static rosidl_runtime_c__type_description__Field etsi_its_cam_ts_msgs__msg__SensorTypes__FIELDS[] = {
  {
    {etsi_its_cam_ts_msgs__msg__SensorTypes__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8_UNBOUNDED_SEQUENCE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {etsi_its_cam_ts_msgs__msg__SensorTypes__FIELD_NAME__bits_unused, 11, 11},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_cam_ts_msgs__msg__SensorTypes__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_cam_ts_msgs__msg__SensorTypes__TYPE_NAME, 36, 36},
      {etsi_its_cam_ts_msgs__msg__SensorTypes__FIELDS, 2, 2},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# SensorTypes ::= BIT STRING {\n"
  "#     undefined         (0),\n"
  "#     radar             (1),\n"
  "#     lidar             (2),\n"
  "#     monovideo         (3),\n"
  "#     stereovision      (4),\n"
  "#     nightvision       (5),\n"
  "#     ultrasonic        (6),\n"
  "#     pmd               (7),\n"
  "#     inductionLoop     (8),\n"
  "#     sphericalCamera   (9),\n"
  "#     uwb               (10),\n"
  "#     acoustic          (11),\n"
  "#     localAggregation  (12),\n"
  "#     itsAggregation    (13)\n"
  "# } (SIZE (16,... ))\n"
  "# ------------------------------------------------------------------------------\n"
  "# * \n"
  "# * This DE indicates the type of sensor(s).\n"
  "# * The corresponding bit shall be set to 1 under the following conditions:\n"
  "# * \n"
  "# * - 0  `undefined`         - in case the sensor type is undefined. \n"
  "# * - 1  `radar`             - in case the sensor is a radar,\n"
  "# * - 2  `lidar`             - in case the sensor is a lidar,\n"
  "# * - 3  `monovideo`         - in case the sensor is mono video,\n"
  "# * - 4  `stereovision`      - in case the sensor is stereo vision,\n"
  "# * - 5  `nightvision`       - in case the sensor is night vision,\n"
  "# * - 6  `ultrasonic`        - in case the sensor is ultrasonic,\n"
  "# * - 7  `pmd`               - in case the sensor is photonic mixing device,\n"
  "# * - 8  `inductionLoop`     - in case the sensor is an induction loop,\n"
  "# * - 9  `sphericalCamera`   - in case the sensor is a spherical camera,\n"
  "# * - 10 `uwb`               - in case the sensor is ultra wide band,\n"
  "# * - 11 `acoustic`          - in case the sensor is acoustic,\n"
  "# * - 12 `localAggregation`  - in case the information is provided by a system that aggregates information from different local sensors. Aggregation may include fusion,\n"
  "# * - 13 `itsAggregation`    - in case the information is provided by a system that aggregates information from other received ITS messages.\n"
  "# * - 14-15                  - are reserved for future usage.\n"
  "# * \n"
  "# * @note: If all bits are set to 0, then no sensor type is used\n"
  "# *\n"
  "# * @category: Sensing Information\n"
  "# * @revision: created in V2.2.1\n"
  "#\n"
  "\n"
  "uint8[] value\n"
  "uint8 bits_unused\n"
  "int64 MIN_SIZE_BITS = 16\n"
  "int64 MAX_SIZE_BITS = 16\n"
  "uint8 BIT_INDEX_UNDEFINED = 0\n"
  "uint8 BIT_INDEX_RADAR = 1\n"
  "uint8 BIT_INDEX_LIDAR = 2\n"
  "uint8 BIT_INDEX_MONOVIDEO = 3\n"
  "uint8 BIT_INDEX_STEREOVISION = 4\n"
  "uint8 BIT_INDEX_NIGHTVISION = 5\n"
  "uint8 BIT_INDEX_ULTRASONIC = 6\n"
  "uint8 BIT_INDEX_PMD = 7\n"
  "uint8 BIT_INDEX_INDUCTION_LOOP = 8\n"
  "uint8 BIT_INDEX_SPHERICAL_CAMERA = 9\n"
  "uint8 BIT_INDEX_UWB = 10\n"
  "uint8 BIT_INDEX_ACOUSTIC = 11\n"
  "uint8 BIT_INDEX_LOCAL_AGGREGATION = 12\n"
  "uint8 BIT_INDEX_ITS_AGGREGATION = 13";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_cam_ts_msgs__msg__SensorTypes__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_cam_ts_msgs__msg__SensorTypes__TYPE_NAME, 36, 36},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 4088, 4088},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_cam_ts_msgs__msg__SensorTypes__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_cam_ts_msgs__msg__SensorTypes__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
