// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_cam_ts_msgs:msg/StationaryVehicleSubCauseCode.idl
// generated code does not contain a copyright notice

#include "etsi_its_cam_ts_msgs/msg/detail/stationary_vehicle_sub_cause_code__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
const rosidl_type_hash_t *
etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x30, 0x6e, 0x1d, 0x41, 0xcf, 0x69, 0xf5, 0x69,
      0x6c, 0xfe, 0x2d, 0xde, 0xa9, 0xa2, 0xa2, 0xd3,
      0x40, 0x75, 0xbd, 0xb6, 0xd6, 0x88, 0x92, 0xf3,
      0xb9, 0x70, 0xfb, 0x0c, 0xb1, 0x74, 0xc2, 0xfd,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__TYPE_NAME[] = "etsi_its_cam_ts_msgs/msg/StationaryVehicleSubCauseCode";

// Define type names, field names, and default values
static char etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__FIELDS[] = {
  {
    {etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__TYPE_NAME, 54, 54},
      {etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# StationaryVehicleSubCauseCode ::= INTEGER {\n"
  "#     unavailable            (0), \n"
  "#     humanProblem           (1), \n"
  "#     vehicleBreakdown       (2), \n"
  "#     postCrash              (3), \n"
  "#     publicTransportStop    (4), \n"
  "#     carryingDangerousGoods (5), \n"
  "#     vehicleOnFire          (6)\n"
  "# } (0..255)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE provides the value of the sub cause codes of the @ref CauseCode \"stationaryVehicle\". \n"
  "# * \n"
  "# * The value shall be set to:\n"
  "# * - 0 `unavailable`           - in case further detailed information on stationary vehicle is unavailable,\n"
  "# * - 1 `humanProblem`          - in case stationary vehicle is due to health problem of driver or passenger,\n"
  "# * - 2 `vehicleBreakdown`      - in case stationary vehicle is due to vehicle break down,\n"
  "# * - 3 `postCrash`             - in case stationary vehicle is caused by collision,\n"
  "# * - 4 `publicTransportStop`   - in case public transport vehicle is stationary at bus stop,\n"
  "# * - 5 `carryingDangerousGoods`- in case the stationary vehicle is carrying dangerous goods,\n"
  "# * - 6 `vehicleOnFire`         - in case of vehicle on fire.\n"
  "# * - 7-255 reserved for future usage.\n"
  "# *\n"
  "# * @category: Traffic information\n"
  "# * @revision: V1.3.1\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 255\n"
  "uint8 UNAVAILABLE = 0\n"
  "uint8 HUMAN_PROBLEM = 1\n"
  "uint8 VEHICLE_BREAKDOWN = 2\n"
  "uint8 POST_CRASH = 3\n"
  "uint8 PUBLIC_TRANSPORT_STOP = 4\n"
  "uint8 CARRYING_DANGEROUS_GOODS = 5\n"
  "uint8 VEHICLE_ON_FIRE = 6";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__TYPE_NAME, 54, 54},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3067, 3067},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_cam_ts_msgs__msg__StationaryVehicleSubCauseCode__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
