// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_cam_ts_msgs:msg/UsageIndication.idl
// generated code does not contain a copyright notice

#include "etsi_its_cam_ts_msgs/msg/detail/usage_indication__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
const rosidl_type_hash_t *
etsi_its_cam_ts_msgs__msg__UsageIndication__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x04, 0x28, 0x21, 0x33, 0x1f, 0xe3, 0xfb, 0xe1,
      0xfd, 0x4d, 0x19, 0xd4, 0x59, 0xb2, 0x0e, 0xe8,
      0xf7, 0x09, 0xce, 0x9a, 0x57, 0xab, 0xdc, 0x6f,
      0x64, 0x0d, 0x34, 0x1f, 0xf5, 0xa9, 0x41, 0x38,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_cam_ts_msgs__msg__UsageIndication__TYPE_NAME[] = "etsi_its_cam_ts_msgs/msg/UsageIndication";

// Define type names, field names, and default values
static char etsi_its_cam_ts_msgs__msg__UsageIndication__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_cam_ts_msgs__msg__UsageIndication__FIELDS[] = {
  {
    {etsi_its_cam_ts_msgs__msg__UsageIndication__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_cam_ts_msgs__msg__UsageIndication__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_cam_ts_msgs__msg__UsageIndication__TYPE_NAME, 40, 40},
      {etsi_its_cam_ts_msgs__msg__UsageIndication__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# UsageIndication ::= ENUMERATED { \n"
  "#     noIndication(0),\n"
  "#     specialUse (1),\n"
  "#     rescueOperation (2),\n"
  "#     ...\n"
  "# }\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE represents indication of how a certain path or area will be used. \n"
  "# * \n"
  "# * The value shall be set to:\n"
  "# * - 0  - ` noIndication `     - in case it will remain free to be used,\n"
  "# * - 1  - ` specialUse `       - in case it will be physically blocked by special use,\n"
  "# * - 2  - ` rescueOperation`   - in case it is intended to be used for rescue operations,\n"
  "# *\n"
  "# * @category: Basic information\n"
  "# * @revision: Created in V2.2.1\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 NO_INDICATION = 0\n"
  "uint8 SPECIAL_USE = 1\n"
  "uint8 RESCUE_OPERATION = 2\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_cam_ts_msgs__msg__UsageIndication__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_cam_ts_msgs__msg__UsageIndication__TYPE_NAME, 40, 40},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2302, 2302},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_cam_ts_msgs__msg__UsageIndication__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_cam_ts_msgs__msg__UsageIndication__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
