// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_cam_ts_msgs:msg/VruEnvironment.idl
// generated code does not contain a copyright notice

#include "etsi_its_cam_ts_msgs/msg/detail/vru_environment__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
const rosidl_type_hash_t *
etsi_its_cam_ts_msgs__msg__VruEnvironment__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xf5, 0x35, 0x82, 0xdb, 0x7c, 0xc9, 0x66, 0xff,
      0xd7, 0x2f, 0x50, 0xe9, 0xb7, 0x43, 0x2d, 0x54,
      0xe1, 0xd6, 0x48, 0x68, 0x69, 0x0e, 0x4a, 0x8e,
      0xa8, 0xc1, 0xb3, 0x1f, 0xfe, 0x96, 0x69, 0x43,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_cam_ts_msgs__msg__VruEnvironment__TYPE_NAME[] = "etsi_its_cam_ts_msgs/msg/VruEnvironment";

// Define type names, field names, and default values
static char etsi_its_cam_ts_msgs__msg__VruEnvironment__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_cam_ts_msgs__msg__VruEnvironment__FIELDS[] = {
  {
    {etsi_its_cam_ts_msgs__msg__VruEnvironment__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_cam_ts_msgs__msg__VruEnvironment__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_cam_ts_msgs__msg__VruEnvironment__TYPE_NAME, 39, 39},
      {etsi_its_cam_ts_msgs__msg__VruEnvironment__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# VruEnvironment ::= INTEGER {\n"
  "#     unavailable             (0), \n"
  "#     intersectionCrossing    (1), \n"
  "#     zebraCrossing           (2), \n"
  "#     sidewalk                (3), \n"
  "#     onVehicleRoad           (4), \n"
  "#     protectedGeographicArea (5)\n"
  "# }(0..15)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE represents the possible VRU environment conditions.\n"
  "# *\n"
  "# * - The value shall be set to:\n"
  "# * - 0 `unavailable`            - to indicate that the information on the type of environment is unavailable,\n"
  "# * - 1 `intersectionCrossing`   - to indicate that the VRU is on an intersection or crossing,\n"
  "# * - 2 `zebraCrossing`          - to indicate that the VRU is on a  zebra crossing (crosswalk),\n"
  "# * - 3 `sidewalk`               - to indicate that the VRU is on a sidewalk,\n"
  "# * - 4 `onVehicleRoad`          - to indicate that the VRU is on a traffic lane,\n"
  "# * - 5 `protectedGeographicArea`- to indicate that the VRU is in a protected area.\n"
  "# * - value 6 to 15              - are reserved for future usage. \n"
  "# *\n"
  "# * @category: VRU information\n"
  "# * @revision: Created in V2.1.1, type changed from ENUMERATED to INTEGER in V2.2.1 and range changed from 0..255 to 0..15\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 15\n"
  "uint8 UNAVAILABLE = 0\n"
  "uint8 INTERSECTION_CROSSING = 1\n"
  "uint8 ZEBRA_CROSSING = 2\n"
  "uint8 SIDEWALK = 3\n"
  "uint8 ON_VEHICLE_ROAD = 4\n"
  "uint8 PROTECTED_GEOGRAPHIC_AREA = 5";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_cam_ts_msgs__msg__VruEnvironment__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_cam_ts_msgs__msg__VruEnvironment__TYPE_NAME, 39, 39},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2986, 2986},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_cam_ts_msgs__msg__VruEnvironment__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_cam_ts_msgs__msg__VruEnvironment__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
