// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_cam_ts_msgs:msg/VruMovementControl.idl
// generated code does not contain a copyright notice

#include "etsi_its_cam_ts_msgs/msg/detail/vru_movement_control__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cam_ts_msgs
const rosidl_type_hash_t *
etsi_its_cam_ts_msgs__msg__VruMovementControl__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x88, 0xb0, 0x5e, 0xa8, 0xb0, 0xe2, 0xf9, 0x58,
      0x18, 0x09, 0x04, 0x0b, 0x2e, 0xf9, 0x56, 0x23,
      0x1e, 0xea, 0x41, 0x38, 0xa2, 0x37, 0x90, 0xf9,
      0x58, 0xec, 0x11, 0x4d, 0x40, 0x97, 0xfe, 0x4e,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_cam_ts_msgs__msg__VruMovementControl__TYPE_NAME[] = "etsi_its_cam_ts_msgs/msg/VruMovementControl";

// Define type names, field names, and default values
static char etsi_its_cam_ts_msgs__msg__VruMovementControl__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_cam_ts_msgs__msg__VruMovementControl__FIELDS[] = {
  {
    {etsi_its_cam_ts_msgs__msg__VruMovementControl__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_cam_ts_msgs__msg__VruMovementControl__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_cam_ts_msgs__msg__VruMovementControl__TYPE_NAME, 43, 43},
      {etsi_its_cam_ts_msgs__msg__VruMovementControl__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# VruMovementControl ::= INTEGER {\n"
  "#     unavailable                (0), \n"
  "#     braking                    (1), \n"
  "#     hardBraking                (2), \n"
  "#     stopPedaling               (3), \n"
  "#     brakingAndStopPedaling     (4), \n"
  "#     hardBrakingAndStopPedaling (5), \n"
  "#     noReaction                 (6) \n"
  "# }(0..15)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# *  This DE indicates the status of the possible human control over a VRU vehicle.\n"
  "# *\n"
  "# * The value shall be set to:\n"
  "# * - 0 `unavailable`                 - to indicate that the information is unavailable,\n"
  "# * - 1 `braking`                     - to indicate that the VRU is braking,\n"
  "# * - 2 `hardBraking`                 - to indicate that the VRU is braking hard,\n"
  "# * - 3 `stopPedaling`                - to indicate that the VRU stopped pedaling,\n"
  "# * - 4 `brakingAndStopPedaling`      - to indicate that the VRU stopped pedaling an is braking,\n"
  "# * - 5 `hardBrakingAndStopPedaling`  - to indicate that the VRU stopped pedaling an is braking hard,\n"
  "# * - 6 `noReaction`                  - to indicate that the VRU is not changing its behavior.\n"
  "# * - 7 to 15                         - are reserved for future usage. \n"
  "# *\n"
  "# * @category: VRU information\n"
  "# * @revision: Created in V2.1.1, type changed from ENUMERATED to INTEGER in V2.2.1 and range changed from 0..255 to 0..15\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 15\n"
  "uint8 UNAVAILABLE = 0\n"
  "uint8 BRAKING = 1\n"
  "uint8 HARD_BRAKING = 2\n"
  "uint8 STOP_PEDALING = 3\n"
  "uint8 BRAKING_AND_STOP_PEDALING = 4\n"
  "uint8 HARD_BRAKING_AND_STOP_PEDALING = 5\n"
  "uint8 NO_REACTION = 6";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_cam_ts_msgs__msg__VruMovementControl__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_cam_ts_msgs__msg__VruMovementControl__TYPE_NAME, 43, 43},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3175, 3175},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_cam_ts_msgs__msg__VruMovementControl__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_cam_ts_msgs__msg__VruMovementControl__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
